<template>
  <div>
    <CustomSubHeader>
      <CBreadcrumb class="border-0 mb-0">{{ title }}</CBreadcrumb>
      <CButton size="sm" color="success" :to="{ name: 'admin-learning-new' }" class="mr-auto">افزودن</CButton>
    </CustomSubHeader>

    <CCard>
      <CCardHeader :dir="paginate ? 'ltr' : 'rtl'" :style="{ textAlign: paginate ? 'center' : 'right' }">
        <el-pagination
          v-if="paginate"
          background
          layout="prev, pager, next"
          :current-page="Number($route.params.page)"
          :page-count="Number(learning.totalPages)"
          @current-change="pageNumber"
        >
        </el-pagination>

        <slot v-else name="header">
          <CIcon name="cil-grid" />
          {{ list_title }}
        </slot>
      </CCardHeader>
      <CCardBody>
        <el-table :data="learning.docs" style="width: 100%">
          <el-table-column type="index" label="#"> </el-table-column>

          <el-table-column label="کاور" width="170">
            <template slot-scope="scope">
              <el-image style="width: 100%; height: 100%" :src="scope.row.thumb" fit="fit"> </el-image>
            </template>
          </el-table-column>

          <el-table-column prop="title" label="عنوان" width=""> </el-table-column>

          <el-table-column prop="short_description" label="توضیح کوتاه" width=""> </el-table-column>

          <el-table-column label="ویرایش" width="105" align="left">
            <template slot-scope="scope">
              <CButton
                :key="scope.row._id"
                color="warning"
                variant="outline"
                :to="`/admin/learning/${$route.params.page}/${scope.row._id}`"
              >
                <i class="fal fa-pencil"></i>
              </CButton>
              <CButton color="danger" variant="outline" @click="del(scope.row._id)">
                <i class="fal fa-trash-alt"></i>
              </CButton>
            </template>
          </el-table-column>
        </el-table>
      </CCardBody>
    </CCard>
  </div>
</template>

<script>
export default {
  name: 'AddminLearningsList',
  layout: 'admin',
  async asyncData({ $axios, params, error }) {
    try {
      const learning = await $axios.get(`/api/public/learning/page/${params.page}`)
      return {
        learning: learning.data
      }
    } catch (err) {
      error({ status: 404, message: 'There is a problem here' })
    }
  },
  data() {
    return {
      title: 'آموزش ها',
      list_title: 'لیست',
      learning: null
    }
  },
  head() {
    return {
      title: this.title
    }
  },
  computed: {
    paginate() {
      return this.learning.totalPages > 1
    }
  },
  methods: {
    pageNumber(val) {
      this.$router.push({ name: 'admin-learning-page', params: { page: val } })
    },
    del(id) {
      this.$confirm('این مورد حذف شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .delete(`/api/admin/learning/${id}`)
            .then(response => {
              this.learning.docs = this.learning.docs.filter(item => item._id !== id)
              this.$message({
                type: 'success',
                message: 'آیتم حذف شد'
              })
            })
            .catch(err => {
              this.$message({
                type: 'error',
                message: err.response.data.message
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    }
  }
}
</script>
